#pragma once
#include "CivTypes.h"
#include <vector>
#include <set>
#include <libpq-fe.h>

#define DLLEXPORT __declspec(dllexport)

// ֶι
#define FiledFilter std::map<Str,std::set<Str>>
class CivDbConnection;

/**
  ݿ࣬ȡݣдݽӿ
*/
class DLLEXPORT  CivDbConnection
{
public:
	// 
	enum TableType
	{
		NODE_TABLE, // 
		PIPE_TABLE, // ߱
		PATTERN_TABLE, // ģʽ
		CURVE_TABLE
	};

	CivDbConnection(char* uri);
	~CivDbConnection();

	/**
	*@brief ȡб
	*@netName: 
	*/
	Tables getTables(StrQuote netName, StrQuote schema = "public");

	/**
	 *@brief ȡݣߣڵ㣬ˮԴȣ
	 *@tableName 
	 */
	Componets getComponets(StrQuote tableName);

	Componets getComponetsByWhere(StrQuote tableName, StrQuote where);

	/**
	 *@brief  ˮã (ڵתΪ)
	 *@tableName 
	 */
	Componets getLikelyPipes(StrQuote tableName);

	bool tableExist(StrQuote tableName);

	/**
	*@brief 
	*@tableName: 
	*@schema: 
	*@tableType߽ͣ
	*/
	bool createTable(StrQuote tableName, StrQuote schema, TableType tableType);

	/**
	*@brief µ
	*@nodeItemsҪµֵ
	*/
	bool updateNode(const NodeResultItems& nodeItems);

	/**
	*@brief ߱
	*@lineItems: 
	*/
	bool updateLink(const LinkResultItems& lineItems);

	bool open();
	void close();

	void addFilter(Str type, Str number);

	FiledFilter getFilter() const;

private:
	bool isValid() const;

	/**
	*@brief ѯӵ
	*@table: ߱
	*@code:
	*/
	Componets getLineByCode(StrQuote table, StrQuote code);

	Componets getNodeByCode(StrQuote table, StrQuote code);

	/**
	*@brief ִsql
	*@sql: Ҫִеsql
	*/
	bool execSql(std::string sql);

	void clearResult();

	/**
	*@brief Ӳѯȡ
	*@result: ѯ
	*@comp: 
	*/
	void getData(PGresult* result, Componets& comp);

private:
	PGconn* mConn;
	PGresult* mResult;
	bool mIsOpen = false;
	char* mUri;

	char* mLastError;

	char mLinkParam[256];
	char mNodeParam[256];

	FiledFilter mFilter; // :Ӧı
};